<html>
  <head>
    <!-- Materialize CSS -->
    <!-- https://materializecss.com/ -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    <!-- React -->
    <!--script crossorigin src="https://unpkg.com/react@18/umd/react.production.min.js"></script>
    <script crossorigin src="https://unpkg.com/react-dom@18/umd/react-dom.production.min.js"></script-->
    <script crossorigin src="https://unpkg.com/react@18/umd/react.development.js"></script>
    <script crossorigin src="https://unpkg.com/react-dom@18/umd/react-dom.development.js"></script>
    <!-- Babel JSX -->
    <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <!-- web3.js -->
    <!-- http://web3js.readthedocs.io/ -->
    <script src="https://unpkg.com/web3@latest/dist/web3.min.js"></script>
  </head>
  <div id="app"></div>
  <script type="text/babel">
    // As import
    const { Component, useState, useEffect } = React;

    // Base App routor
    const routes = {
      index: () => <Index />,
      block: () => <Block />,
      transaction: () => <div />,
      token: () => <Token />,
    };
    const App = () => {
      const [route, setRoute] = useState('index');
      const renderNavItem = (key: string) => (
        <li key={key}><a onClick={() => setRoute(key)}>{key[0].toUpperCase()}{key.substr(1)}</a></li>
      );

      return (
        <div className="main-wrapper">
          <nav>
            <div className="nav-wrapper">
              <div className="brand-logo">
                Explorer <a href="https://etherscan.io">https://etherscan.io</a>
              </div>
              <ul id="nav-mobile" className="right hide-on-med-and-down">
                {Object.keys(routes).map((k: string) => renderNavItem(k))}
              </ul>
            </div>
          </nav>
          {routes[route]()}
        </div>
      );
    };

    // Render
    const domContainer = document.querySelector('#app');
    const root = ReactDOM.createRoot(domContainer);
    root.render(<App />);

    // Web3 Networks
    // RPCs: https://rpc.info/
    const rpc_eth_mainnet = 'https://rpc.ankr.com/eth';
    const rpc_ethw_mainnet = 'https://mainnet.ethereumpow.org';

    const provider = rpc_eth_mainnet;
    const web3 = new Web3(provider);

    // ABI sources
    const abis = {
      erc20:
        '[{"constant":true,"inputs":[],"name":"name","outputs":[{"name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_spender","type":"address"},{"name":"_value","type":"uint256"}],"name":"approve","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_from","type":"address"},{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transferFrom","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"decimals","outputs":[{"name":"","type":"uint8"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"}],"name":"balanceOf","outputs":[{"name":"balance","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"symbol","outputs":[{"name":"","type":"string"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transfer","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"},{"name":"_spender","type":"address"}],"name":"allowance","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"payable":true,"stateMutability":"payable","type":"fallback"},{"anonymous":false,"inputs":[{"indexed":true,"name":"owner","type":"address"},{"indexed":true,"name":"spender","type":"address"},{"indexed":false,"name":"value","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"from","type":"address"},{"indexed":true,"name":"to","type":"address"},{"indexed":false,"name":"value","type":"uint256"}],"name":"Transfer","type":"event"}]',
      erc721:
        '[{"constant":false,"inputs":[{"internalType":"address","name":"to","type":"address"},{"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"approve","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"to","type":"address"},{"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"mint","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"from","type":"address"},{"internalType":"address","name":"to","type":"address"},{"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"safeTransferFrom","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"from","type":"address"},{"internalType":"address","name":"to","type":"address"},{"internalType":"uint256","name":"tokenId","type":"uint256"},{"internalType":"bytes","name":"_data","type":"bytes"}],"name":"safeTransferFrom","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"to","type":"address"},{"internalType":"bool","name":"approved","type":"bool"}],"name":"setApprovalForAll","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"internalType":"address","name":"from","type":"address"},{"internalType":"address","name":"to","type":"address"},{"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"transferFrom","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"inputs":[],"payable":false,"stateMutability":"nonpayable","type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"from","type":"address"},{"indexed":true,"internalType":"address","name":"to","type":"address"},{"indexed":true,"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"Transfer","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"owner","type":"address"},{"indexed":true,"internalType":"address","name":"approved","type":"address"},{"indexed":true,"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"owner","type":"address"},{"indexed":true,"internalType":"address","name":"operator","type":"address"},{"indexed":false,"internalType":"bool","name":"approved","type":"bool"}],"name":"ApprovalForAll","type":"event"},{"constant":true,"inputs":[{"internalType":"address","name":"owner","type":"address"}],"name":"balanceOf","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"getApproved","outputs":[{"internalType":"address","name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"internalType":"address","name":"owner","type":"address"},{"internalType":"address","name":"operator","type":"address"}],"name":"isApprovedForAll","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"internalType":"uint256","name":"tokenId","type":"uint256"}],"name":"ownerOf","outputs":[{"internalType":"address","name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"internalType":"bytes4","name":"interfaceId","type":"bytes4"}],"name":"supportsInterface","outputs":[{"internalType":"bool","name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"}]',
      erc1155:
        '[{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"account","type":"address"},{"indexed":true,"internalType":"address","name":"operator","type":"address"},{"indexed":false,"internalType":"bool","name":"approved","type":"bool"}],"name":"ApprovalForAll","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"operator","type":"address"},{"indexed":true,"internalType":"address","name":"from","type":"address"},{"indexed":true,"internalType":"address","name":"to","type":"address"},{"indexed":false,"internalType":"uint256[]","name":"ids","type":"uint256[]"},{"indexed":false,"internalType":"uint256[]","name":"values","type":"uint256[]"}],"name":"TransferBatch","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"operator","type":"address"},{"indexed":true,"internalType":"address","name":"from","type":"address"},{"indexed":true,"internalType":"address","name":"to","type":"address"},{"indexed":false,"internalType":"uint256","name":"id","type":"uint256"},{"indexed":false,"internalType":"uint256","name":"value","type":"uint256"}],"name":"TransferSingle","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"internalType":"string","name":"value","type":"string"},{"indexed":true,"internalType":"uint256","name":"id","type":"uint256"}],"name":"URI","type":"event"},{"inputs":[{"internalType":"address","name":"account","type":"address"},{"internalType":"uint256","name":"id","type":"uint256"}],"name":"balanceOf","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address[]","name":"accounts","type":"address[]"},{"internalType":"uint256[]","name":"ids","type":"uint256[]"}],"name":"balanceOfBatch","outputs":[{"internalType":"uint256[]","name":"","type":"uint256[]"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"account","type":"address"},{"internalType":"address","name":"operator","type":"address"}],"name":"isApprovedForAll","outputs":[{"internalType":"bool","name":"","type":"bool"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"from","type":"address"},{"internalType":"address","name":"to","type":"address"},{"internalType":"uint256[]","name":"ids","type":"uint256[]"},{"internalType":"uint256[]","name":"amounts","type":"uint256[]"},{"internalType":"bytes","name":"data","type":"bytes"}],"name":"safeBatchTransferFrom","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"internalType":"address","name":"from","type":"address"},{"internalType":"address","name":"to","type":"address"},{"internalType":"uint256","name":"id","type":"uint256"},{"internalType":"uint256","name":"amount","type":"uint256"},{"internalType":"bytes","name":"data","type":"bytes"}],"name":"safeTransferFrom","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"internalType":"address","name":"operator","type":"address"},{"internalType":"bool","name":"approved","type":"bool"}],"name":"setApprovalForAll","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"internalType":"bytes4","name":"interfaceId","type":"bytes4"}],"name":"supportsInterface","outputs":[{"internalType":"bool","name":"","type":"bool"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"uint256","name":"id","type":"uint256"}],"name":"uri","outputs":[{"internalType":"string","name":"","type":"string"}],"stateMutability":"view","type":"function"}]',
    };

    // Dev accounts
    const account1 = {
      address: '0xdd9D509aF7b70B023040850268D00eb36e75eB12',
      privateKey: '0xc94ec474367cb1406d183a39361336819cb8d2cd9392ced6ee855e5a20be5e58',
    };

    const account = account1;
    web3.eth.accounts.privateKeyToAccount(account.privateKey);
    web3.eth.accounts.wallet.add(account);

    // All layout components
    const Index = () => {
      const [node, setNode] = useState(null);
      const getNode = async () => {
        const block = await web3.eth.getBlock('latest');
        setNode({
          Node: await web3.eth.getNodeInfo(),
          'Latest Block': block.hash,
          'Block Height': block.number,
          'Timestamp': new Date(block.timestamp * 1000).toGMTString(),
          'No. of Transactions': block.transactions.length,
          'Block Size': `${block.size} bytes`,
          'Gas Used': `${block.gasUsed} (${(block.gasUsed/block.gasLimit*100).toFixed(2)}%)`,
          'Gas Limit': block.gasLimit,
        });
      };
      useEffect(() => {
        if (node) return;
        getNode();
      });
      return (
        <div>
          <div className="row">
            <div className="col s6">
              <h4>
                <i className="material-icons">info</i>
                Node Infomation
                <a className="btn" onClick={getNode}><i className="material-icons">sync</i></a>
              </h4>
              <table>
                <tbody>
                  {!node ? null : Object.keys(node).map(k => (
                    <tr key={k}>
                      <td>{k}</td>
                      <td>{node && node[k] ? node[k] : null}</td>
                    </tr>
                  ))}
                </tbody>
              </table>
            </div>
          </div>
        </div>
      );
    };

    const Block = () => {
      const [blockNum, setBlockNum] = useState('');
      const [block, setBlock] = useState(null);
      const getBlock = async (input = '') => {
        const num = parseInt(input);
        const block = await web3.eth.getBlock(num || 'latest', true);
        setBlock(block);
      };
      useEffect(() => {
        if (block) return;
        getBlock();
      });

      return (
        <div>
          <style dangerouslySetInnerHTML={{__html: `
            .hash-text {
              width: 300px;
              overflow: hidden;
            }
          `}} />
          <div className="row">
            <input type="text" placeholder="block height" style={{ width: '80%' }} onChange={(e) => setBlockNum(e.target.value)} />
            <a className="btn" onClick={() => getBlock(blockNum)}><i className="material-icons">search</i></a>
          </div>
          {!block ? null : (
            <div>
              <h5>Block #{block.number}</h5>
              <p>A total of {block.transactions.length} transactions found</p>
              <div style={{ overflow: 'scroll', height: '80vh' }}>
                <table>
                  <thead>
                    <tr>
                      <th>Txn Hash</th>
                      <th>Status</th>
                      <th>Block</th>
                      <th>From</th>
                      <th>To</th>
                      <th>Value</th>
                      <th>Txn Fee</th>
                    </tr>
                  </thead>
                  <tbody>
                    {block.transactions.map(tx => (
                      <tr key={tx.hash}>
                        <td><p className="hash-text">{tx.hash}</p></td>
                        <td>{tx.transactionIndex ? <i className="material-icons green">check</i> : <i class="material-icons grey">sync</i>}</td>
                        <td>{tx.blockNumber}</td>
                        <td><p className="hash-text">{tx.from}</p></td>
                        <td><p className="hash-text">{tx.to}</p></td>
                        <td>{web3.utils.fromWei(tx.value, 'ether')} Ether</td>
                        <td>{web3.utils.fromWei(tx.gasPrice, 'ether')}</td>
                      </tr>
                    ))}
                  </tbody>
                </table>
              </div>
            </div>
          )}
        </div>
      );
    };

    const Token = () => {
      const croAddress = '0xa0b73e1ff0b80914ab6fe0444e65848c4c34450b';
      const [address, setAddress] = useState(croAddress);
      const [abi, setAbi] = useState(Object.keys(abis)[0]);
      const [token, setToken] = useState(null);
      const [tokenInfo, setTokenInfo] = useState({});

      const getContract = async (addr = '') => {
        const contract = new web3.eth.Contract(JSON.parse(abis[abi]), address);
        const info = {
          token_type: abi.toUpperCase(),
          name: contract.methods.name ? await contract.methods.name().call() : null,
          symbol: contract.methods.symbol ?  await contract.methods.symbol().call() : null,
          totalSupply: contract.methods.totalSupply ? await contract.methods.totalSupply().call() : null,
          decimals: contract.methods.decimals ? await contract.methods.decimals().call() : null,
        };
        setToken(contract);
        setTokenInfo(info);
      };

      return (
        <div>
          <div className="row">
            <select style={{ width: '10%', display: 'inline-block' }} onChange={(e) => setAbi(e.target.value)}>
              {Object.keys(abis).map(std => (
                <option key={std} value={std}>{std.toUpperCase()}</option>
              ))}
            </select>
            <input type="text" placeholder="address" style={{ width: '80%' }} onChange={(e) => setAddress(e.target.value)} />
            <a className="btn" onClick={() => getContract(address)}><i className="material-icons">search</i></a>
          </div>
          {!token ? null : (
            <div className="row">
              <pre>
                {JSON.stringify(tokenInfo)}
              </pre>
            </div>
          )}
        </div>
      );
    };
  </script>
</html>
